

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)

The #PangoAttrFloat structure is used to represent attributes with
a float or double value.
-}

module GI.Pango.Structs.AttrFloat
    ( 

-- * Exported types
    AttrFloat(..)                           ,
    newZeroAttrFloat                        ,
    noAttrFloat                             ,


 -- * Properties
-- ** Attr
    attrFloatReadAttr                       ,


-- ** Value
    attrFloatReadValue                      ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Pango.Types
import GI.Pango.Callbacks

newtype AttrFloat = AttrFloat (ForeignPtr AttrFloat)
-- | Construct a `AttrFloat` struct initialized to zero.
newZeroAttrFloat :: MonadIO m => m AttrFloat
newZeroAttrFloat = liftIO $ callocBytes 24 >>= wrapPtr AttrFloat

noAttrFloat :: Maybe AttrFloat
noAttrFloat = Nothing

attrFloatReadAttr :: AttrFloat -> IO Attribute
attrFloatReadAttr s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO (Ptr Attribute)
    val' <- (newPtr 16 Attribute) val
    return val'

attrFloatReadValue :: AttrFloat -> IO Double
attrFloatReadValue s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 16) :: IO CDouble
    let val' = realToFrac val
    return val'

type family ResolveAttrFloatMethod (t :: Symbol) (o :: *) :: * where
    ResolveAttrFloatMethod l o = MethodResolutionFailed l o

instance (info ~ ResolveAttrFloatMethod t AttrFloat, MethodInfo info AttrFloat p) => IsLabelProxy t (AttrFloat -> p) where
    fromLabelProxy _ = overloadedMethod (MethodProxy :: MethodProxy info)

#if MIN_VERSION_base(4,9,0)
instance (info ~ ResolveAttrFloatMethod t AttrFloat, MethodInfo info AttrFloat p) => IsLabel t (AttrFloat -> p) where
    fromLabel _ = overloadedMethod (MethodProxy :: MethodProxy info)
#endif


